define(["require", "exports", "cheerio"], function (require, exports, cheerio) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.decodeHtml = void 0;
    function decodeHtml(html) {
        if (!html) {
            return null;
        }
        var result = cheerio.parseHTML(html)[0];
        if (!result)
            return '';
        return result.data;
    }
    exports.decodeHtml = decodeHtml;
});
