define(["require", "exports"], function (require, exports) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.equal = exports.ok = void 0;
    /**
     * Throws an error, if value is not a javascript value
     */
    function ok(value, message) {
        if (!value || value === null) {
            throw new Error(message ? "Assertion failed (" + message + ")" : 'Assertion failed');
        }
    }
    exports.ok = ok;
    /**
     * Throws an error, ifi two values are not equal
     */
    function equal(a, b, message) {
        if (a != b) {
            throw new Error(message ? "Not Equal: (" + message + ")" : "Not Equal: " + a + " != " + b);
        }
    }
    exports.equal = equal;
});
