define(["require", "exports", "assert", "mocha", "chord/base/common/lru"], function (require, exports, assert, mocha_1, lru_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    mocha_1.suite('platform/utils/common/lru', function () {
        mocha_1.test('LRUCache', function () {
            var cache = new lru_1.LRUCache(0.2);
            cache.set('1', 1);
            setTimeout(function () { assert.equal(cache.get('1'), null); }, 500);
        });
    });
});
