define(["require", "exports", "request"], function (require, exports, r) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.makeCookieFrom = exports.makeCookie = exports.makeCookies = exports.makeCookieJar = void 0;
    function makeCookieJar() {
        return r.jar();
    }
    exports.makeCookieJar = makeCookieJar;
    function makeCookies(rawCookies, jar) {
        var cookies = rawCookies.map(function (rawCookie) { return makeCookieFrom(rawCookie); });
        return cookies;
    }
    exports.makeCookies = makeCookies;
    function makeCookie(key, value, domain) {
        var s = key + "=" + value + "; domain=" + (domain ? domain : '');
        return makeCookieFrom(s);
    }
    exports.makeCookie = makeCookie;
    function makeCookieFrom(input) {
        return r.cookie(input);
    }
    exports.makeCookieFrom = makeCookieFrom;
});
