define(["require", "exports", "path", "os", "fs", "chord/base/common/platform", "chord/base/node/pfs"], function (require, exports, paths, os, fs, platform_1, pfs_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CHORD_DIR = void 0;
    exports.CHORD_DIR = platform_1.isWindows ?
        paths.join(os.homedir(), 'Appdata', 'Roaming', 'chord') : paths.join(os.homedir(), '.chord');
    if (!fs.existsSync(exports.CHORD_DIR)) {
        pfs_1.mkdirp(exports.CHORD_DIR);
    }
});
