define(["require", "exports", "chord/workbench/api/common/state/offset"], function (require, exports, offset_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.initiateSearchViewState = exports.initiateSearchHistoryState = exports.initiateSearchResultState = void 0;
    function initiateSearchResultState() {
        return {
            view: 'top',
            songs: [],
            albums: [],
            artists: [],
            collections: [],
            episodes: [],
            podcasts: [],
            radios: [],
            songsOffset: offset_1.initiateOffset(),
            albumsOffset: offset_1.initiateOffset(),
            artistsOffset: offset_1.initiateOffset(),
            collectionsOffset: offset_1.initiateOffset(),
            episodesOffset: offset_1.initiateOffset(),
            podcastsOffset: offset_1.initiateOffset(),
            radiosOffset: offset_1.initiateOffset(),
        };
    }
    exports.initiateSearchResultState = initiateSearchResultState;
    function initiateSearchHistoryState() {
        return {
            keywords: [],
        };
    }
    exports.initiateSearchHistoryState = initiateSearchHistoryState;
    function initiateSearchViewState() {
        return {
            view: 'searchHistory',
            keyword: '',
            history: initiateSearchHistoryState(),
            result: initiateSearchResultState(),
        };
    }
    exports.initiateSearchViewState = initiateSearchViewState;
});
