define(["require", "exports", "react"], function (require, exports, React) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.MiddleButton = exports.SmallButton = exports.MenuButton = void 0;
    function MenuButton(_a) {
        var click = _a.click;
        return (React.createElement("div", { className: "react-contextmenu-wrapper", onClick: function (e) { return click(e); } },
            React.createElement("button", { className: "btn btn-transparent btn--narrow cursor-pointer", title: "More" },
                React.createElement("div", { className: "spoticon-ellipsis-24" }))));
    }
    exports.MenuButton = MenuButton;
    function SmallButton(props) {
        return (React.createElement("button", { className: "btn btn-green btn-tiny btn--no-margin cursor-pointer", onClick: function (e) { return props.click(e); } }, props.title));
    }
    exports.SmallButton = SmallButton;
    function MiddleButton(props) {
        return (React.createElement("button", { className: "btn btn-green btn-small btn--no-margin cursor-pointer", onClick: function (e) { return props.click(e); } }, props.title));
    }
    exports.MiddleButton = MiddleButton;
});
