var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "chord/platform/utils/common/keys", "chord/workbench/parts/common/component/viewMoreItem", "chord/workbench/parts/common/component/artistItem"], function (require, exports, React, keys_1, viewMoreItem_1, artistItem_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var ArtistListView = /** @class */ (function (_super) {
        __extends(ArtistListView, _super);
        function ArtistListView(props) {
            var _this = _super.call(this, props) || this;
            _this._getArtistsView = _this._getArtistsView.bind(_this);
            return _this;
        }
        ArtistListView.prototype._getArtistsView = function (size) {
            var artists = this.props.artists;
            var artistsView = artists.slice(0, size ? size : Infinity).map(function (artist, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: keys_1.makeListKey(index, 'artist', 'list') },
                React.createElement(artistItem_1.default, { artist: artist }))); });
            return artistsView;
        };
        ArtistListView.prototype.render = function () {
            var _this = this;
            var more = this.props.more;
            var artistsView = this._getArtistsView();
            var viewMore = more ? (React.createElement(viewMoreItem_1.ViewMoreItem, { handler: function () { return _this.props.handleGetMoreArtists(); } })) : null;
            return (React.createElement("section", { className: 'artist-artists' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center', display: 'none' } }, "Artists"),
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'align-row-wrap grid--limit row' }, artistsView)),
                    viewMore)));
        };
        return ArtistListView;
    }(React.Component));
    exports.default = ArtistListView;
});
// function mapStateToProps(state: IStateGlobal) {
// let { artists } = state.mainView.homeView.artistsView;
// return { artists };
// }
// function mapDispatchToProps(dispatch) {
// return {
// handleGetMoreArtists: (...args) => handleGetMoreArtists(...args).then(act => dispatch(act)),
// };
// }
// export default connect(mapStateToProps)(ArtistListView);
