var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "react", "react-redux", "chord/platform/utils/common/keys", "chord/music/common/origin", "chord/workbench/parts/common/component/buttons", "chord/workbench/parts/mainView/browser/component/home/component/artists/artistList", "chord/workbench/parts/mainView/browser/action/home/artists", "chord/music/xiami/common", "chord/music/netease/common", "chord/music/qq/common"], function (require, exports, React, react_redux_1, keys_1, origin_1, buttons_1, artistList_1, artists_1, common_1, common_2, common_3) {
    'use strict';
    var _a, _b;
    Object.defineProperty(exports, "__esModule", { value: true });
    var ARTIST_SIZE = 40;
    // origin function argument to ArtistListOptionsView.state
    var ARGUMENT_NAMES_MAP = (_a = {},
        _a[origin_1.ORIGIN.xiami] = {
            language: 'area',
            tag: 'genre',
            gender: 'gender',
            index: 'index',
        },
        _a[origin_1.ORIGIN.netease] = {
            category: 'genre',
            initial: 'index',
        },
        _a[origin_1.ORIGIN.qq] = {
            area: 'area',
            genre: 'genre',
            sex: 'gender',
            index: 'index',
        },
        _a);
    function hash(area, genre, gender, index) {
        return [area, genre, gender, index].map(function (arg) { return arg == null ? 'null' : arg; }).join('|');
    }
    function initiateState(origin) {
        switch (origin) {
            case origin_1.ORIGIN.xiami:
                return {
                    area: '0',
                    genre: '0',
                    gender: '0',
                    index: null,
                };
            case origin_1.ORIGIN.netease:
                return {
                    area: null,
                    genre: null,
                    gender: null,
                    index: '-1',
                };
            case origin_1.ORIGIN.qq:
                return {
                    area: '-100',
                    genre: '-100',
                    gender: '-100',
                    index: '-100',
                };
            default:
                throw new Error("[ERROR] [ArtistListOptionsView.initiateState] Here will never be occured. [args]: " + origin);
        }
    }
    var OPTIONS_SET = (_b = {},
        _b[origin_1.ORIGIN.xiami] = common_1.ARTIST_LIST_OPTIONS,
        _b[origin_1.ORIGIN.netease] = common_2.ARTIST_LIST_OPTIONS,
        _b[origin_1.ORIGIN.qq] = common_3.ARTIST_LIST_OPTIONS,
        _b);
    var ArtistListOptionsView = /** @class */ (function (_super) {
        __extends(ArtistListOptionsView, _super);
        function ArtistListOptionsView(props) {
            var _this = _super.call(this, props) || this;
            _this.state = __assign(__assign({}, initiateState(_this.props.origin)), { artists: [] });
            _this.artistsMap = {};
            _this.currentLength = 0;
            _this.more = true;
            _this._handleShowArtistListView = _this._handleShowArtistListView.bind(_this);
            _this._hash = _this._hash.bind(_this);
            _this._getArtistList = _this._getArtistList.bind(_this);
            _this._showMoreArtists = _this._showMoreArtists.bind(_this);
            _this._showArtistList = _this._showArtistList.bind(_this);
            _this._update_argument = _this._update_argument.bind(_this);
            _this._getTitleView = _this._getTitleView.bind(_this);
            _this._getOptionView = _this._getOptionView.bind(_this);
            _this._getOptionsView = _this._getOptionsView.bind(_this);
            _this._getArtistListOptionsView = _this._getArtistListOptionsView.bind(_this);
            return _this;
        }
        ArtistListOptionsView.prototype._hash = function () {
            var _a = this.state, area = _a.area, genre = _a.genre, gender = _a.gender, index = _a.index;
            return hash(area, genre, gender, index);
        };
        ArtistListOptionsView.prototype._getArtistList = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a, area, genre, gender, index, origin, h_1, h, offset;
                var _this = this;
                return __generator(this, function (_b) {
                    _a = this.state, area = _a.area, genre = _a.genre, gender = _a.gender, index = _a.index;
                    origin = this.props.origin;
                    if (origin == origin_1.ORIGIN.xiami) {
                        h_1 = hash(area, genre, gender, null);
                        if (this.artistsMap[h_1])
                            return [2 /*return*/];
                    }
                    h = this._hash();
                    offset = (this.artistsMap[h] || []).length;
                    return [2 /*return*/, artists_1.handleGetArtists(origin, area, genre, gender, index, offset, ARTIST_SIZE)
                            .then(function (items) {
                            if (origin == origin_1.ORIGIN.xiami) {
                                var _a = __read(items, 2), artists = _a[0], pinyins = _a[1];
                                var seq = artists.findIndex(function (artist) { return artist == null; });
                                var hotArtists = artists.slice(0, seq);
                                var otherArtists = artists.slice(seq + 1);
                                var h_2 = hash(area, genre, gender, null);
                                _this.artistsMap[h_2] = hotArtists;
                                for (var i = 0; i < otherArtists.length; i += 1) {
                                    var artist = otherArtists[i];
                                    var pinyin = pinyins[seq + 1 + i].trim();
                                    var code = pinyin ? pinyin[0].toUpperCase().charCodeAt(0) - 65 : -1;
                                    var hstr = (code >= 0 && code <= 25) ? pinyin[0].toUpperCase() : '#';
                                    var h_3 = hash(area, genre, gender, hstr);
                                    var list = _this.artistsMap[h_3] || [];
                                    list.push(artist);
                                    _this.artistsMap[h_3] = list;
                                }
                            }
                            else {
                                var artists = items;
                                var h_4 = hash(area, genre, gender, index);
                                var list = _this.artistsMap[h_4] || [];
                                _this.artistsMap[h_4] = __spread(list, artists);
                                if (artists.length < ARTIST_SIZE) {
                                    _this.more = false;
                                }
                            }
                        })];
                });
            });
        };
        ArtistListOptionsView.prototype._showArtistList = function () {
            var _this = this;
            // reset
            this.currentLength = ARTIST_SIZE;
            this.more = true;
            var h = this._hash();
            var artists = (this.artistsMap[h] || []).slice(0, ARTIST_SIZE);
            if (artists.length > 0) {
                this.setState({ artists: artists });
            }
            else {
                this._getArtistList()
                    .then(function () {
                    var artists = _this.artistsMap[h].slice(0, ARTIST_SIZE);
                    _this.setState({ artists: artists });
                });
            }
        };
        ArtistListOptionsView.prototype._showMoreArtists = function () {
            var _this = this;
            var h = this._hash();
            var origin = this.props.origin;
            this.currentLength = this.currentLength + ARTIST_SIZE;
            if (origin == origin_1.ORIGIN.xiami) {
                if (this.currentLength > this.artistsMap[h].length) {
                    this.more = false;
                }
                var artists = this.artistsMap[h].slice(0, this.currentLength);
                this.setState({ artists: artists });
            }
            this._getArtistList()
                .then(function () {
                if (_this.currentLength > _this.artistsMap[h].length) {
                    _this.more = false;
                }
                var artists = _this.artistsMap[h].slice(0, _this.currentLength);
                _this.setState({ artists: artists });
            });
        };
        ArtistListOptionsView.prototype._handleShowArtistListView = function () {
            var _this = this;
            this._showArtistList();
            process.nextTick(function () { return _this.props.handleShowArtistListView(_this.props.origin); });
        };
        ArtistListOptionsView.prototype._update_argument = function (name, value) {
            var _a;
            var origin = this.props.origin;
            var key = ARGUMENT_NAMES_MAP[origin][name];
            this.setState((_a = {}, _a[key] = value, _a));
        };
        ArtistListOptionsView.prototype._getTitleView = function (title) {
            return (React.createElement("div", { className: 'chunk-title' }, title));
        };
        ArtistListOptionsView.prototype._getOptionView = function (option) {
            var _this = this;
            var type = option.type;
            var origin = this.props.origin;
            var list = option.items.map(function (item, index) {
                var key = ARGUMENT_NAMES_MAP[origin][type];
                var active = _this.state[key] == item.id;
                var className = active ? 'chunk-item chunk-item-selected a-like cursor-pointer'
                    : 'chunk-item a-like cursor-pointer';
                return (React.createElement("div", { className: className, key: keys_1.makeListKey(index, 'artist', 'option', 'item'), onClick: function () { return _this._update_argument(type, item.id); } }, item.name));
            });
            return (React.createElement("div", { className: 'chunk-container' }, list));
        };
        ArtistListOptionsView.prototype._getOptionsView = function (options) {
            var _this = this;
            var classes = options.map(function (option, index) {
                var titleView = _this._getTitleView(option.name);
                var optionView = _this._getOptionView(option);
                return (React.createElement("div", { className: 'chunk', key: keys_1.makeListKey(index, 'artist', 'option') },
                    titleView,
                    optionView));
            });
            return classes;
        };
        ArtistListOptionsView.prototype._getArtistListOptionsView = function (options) {
            var origin = this.props.origin;
            var classes = this._getOptionsView(options);
            return (React.createElement("div", { className: 'options-item' },
                React.createElement("div", { className: 'options-item-title' },
                    " ",
                    origin.toLocaleUpperCase(),
                    " "),
                React.createElement("div", { className: 'options-item-container' },
                    " ",
                    classes,
                    " ")));
        };
        ArtistListOptionsView.prototype.render = function () {
            var _this = this;
            var origin = this.props.origin;
            var options = OPTIONS_SET[origin];
            var artistListOptionsView = this._getArtistListOptionsView(options);
            var artistListView = (this.props.toShowArtistList() && this.props.view == 'artists') ? (React.createElement(artistList_1.default, { artists: this.state.artists, more: this.more, handleGetMoreArtists: function () { return _this._showMoreArtists(); } })) : null;
            return (React.createElement("div", null,
                React.createElement("div", { className: 'options-container' },
                    artistListOptionsView,
                    React.createElement("div", { className: 'options-container-title' },
                        React.createElement(buttons_1.MiddleButton, { title: "Show Me", click: this._handleShowArtistListView }))),
                artistListView));
        };
        return ArtistListOptionsView;
    }(React.Component));
    function mapStateToProps(state) {
        var view = state.mainView.homeView.artistsView.view;
        return { view: view };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handleShowArtistListView: function (origin) { return dispatch(artists_1.handleShowArtistListView(origin)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(ArtistListOptionsView);
});
