var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
define(["require", "exports", "react", "react-redux", "chord/music/common/origin", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/base/common/time", "chord/workbench/parts/common/component/common", "chord/workbench/parts/common/component/episodeItem", "chord/workbench/parts/common/component/pagination", "chord/workbench/parts/common/component/navMenu", "chord/workbench/parts/player/browser/action/playPodcast", "chord/workbench/parts/menu/browser/action/menu", "chord/workbench/parts/mainView/browser/action/showRadio", "chord/workbench/events/autoLoadNextPlayItems", "chord/sound/core/api", "chord/sound/common/params"], function (require, exports, React, react_redux_1, origin_1, statistic_1, size_1, time_1, common_1, episodeItem_1, pagination_1, navMenu_1, playPodcast_1, menu_1, showRadio_1, autoLoadNextPlayItems_1, api_1, params_1) {
    'use strict';
    var _a;
    Object.defineProperty(exports, "__esModule", { value: true });
    function PodcastEntity(_a) {
        var podcast = _a.podcast, handlePlayPodcast = _a.handlePlayPodcast, handleShowRadioViewById = _a.handleShowRadioViewById, showPodcastMenu = _a.showPodcastMenu;
        var cover = podcast.podcastCoverPath || api_1.soundApi.resizeImageUrl(podcast.origin, podcast.podcastCoverUrl, size_1.ESize.Large);
        return (React.createElement("header", { className: 'entity-info' },
            React.createElement("div", null,
                React.createElement("div", { draggable: true },
                    React.createElement("div", { className: "media-object" },
                        React.createElement("div", { className: "media-object-hoverable" },
                            React.createElement("div", { className: "react-contextmenu-wrapper", onContextMenu: function (e) { return showPodcastMenu(e, podcast); } },
                                React.createElement("div", { className: "cover-art shadow cover-art--with-auto-height", "aria-hidden": "true", style: { width: 'auto', height: 'auto' } },
                                    React.createElement("div", null,
                                        common_1.PodcastIcon,
                                        React.createElement("div", { className: "cover-art-image cover-art-image-loaded", style: { backgroundImage: "url(\"" + cover + "\")" } })))))))),
            React.createElement(PodcastInfo, { podcast: podcast, handlePlayPodcast: handlePlayPodcast, handleShowRadioViewById: handleShowRadioViewById })));
    }
    function PodcastInfo(_a) {
        var podcast = _a.podcast, handlePlayPodcast = _a.handlePlayPodcast, handleShowRadioViewById = _a.handleShowRadioViewById;
        var likeAndPlayCount = statistic_1.getLikeAndPlayCount(podcast);
        return (React.createElement("div", { className: 'media-bd' },
            React.createElement("div", { className: 'entity-name' },
                React.createElement("h2", null, podcast.podcastName),
                React.createElement("div", null,
                    React.createElement("span", null, "By "),
                    React.createElement("span", { className: 'link-subtle a-like cursor-pointer', onClick: function () { return handleShowRadioViewById(podcast.radioId); } }, podcast.radioName))),
            React.createElement("p", { className: "text-silence entity-additional-info" }, likeAndPlayCount),
            React.createElement("p", { className: "text-silence entity-additional-info" },
                time_1.getDateYear(podcast.releaseDate),
                " \u2022 ",
                podcast.episodeCount,
                " episodes"),
            React.createElement("button", { className: "btn btn-green cursor-pointer", onClick: function () { return handlePlayPodcast(podcast); } }, "PLAY THE EPISODES BELOW")));
    }
    var INIT_STATES = (_a = {},
        _a[origin_1.ORIGIN.ximalaya] = __assign(__assign({ episodes: null, total: null }, params_1.OFFSETS[origin_1.ORIGIN.ximalaya]), { order: params_1.DEFAULT_ORDER[origin_1.ORIGIN.ximalaya].podcast.episodes }),
        _a[origin_1.ORIGIN.himalaya] = __assign(__assign({ episodes: null, total: null }, params_1.OFFSETS[origin_1.ORIGIN.himalaya]), { order: params_1.DEFAULT_ORDER[origin_1.ORIGIN.himalaya].podcast.episodes }),
        _a);
    var PodcastView = /** @class */ (function (_super) {
        __extends(PodcastView, _super);
        function PodcastView(props) {
            var _this = _super.call(this, props) || this;
            _this.state = __assign({}, INIT_STATES[_this.props.podcast.origin]);
            _this.changePage = _this.changePage.bind(_this);
            _this.changeOrder = _this.changeOrder.bind(_this);
            _this.addGlobelPlayPart = _this.addGlobelPlayPart.bind(_this);
            _this.handlePlayPodcast = _this.handlePlayPodcast.bind(_this);
            return _this;
        }
        PodcastView.prototype.changeOrder = function (order) {
            var _this = this;
            var limit = this.state.limit;
            this.getEpisodes(0, limit, order)
                .then(function (episodes) { return _this.setState({
                episodes: episodes,
                offset: 0,
                order: order,
            }); });
        };
        // page is from 1
        PodcastView.prototype.changePage = function (nextPage) {
            var _this = this;
            var _a = this.state, limit = _a.limit, order = _a.order;
            this.getEpisodes(nextPage - 1, limit, order)
                .then(function (episodes) { return _this.setState({
                episodes: episodes,
                offset: nextPage - 1,
            }); });
        };
        // offset is from 0
        PodcastView.prototype.getEpisodes = function (offset, limit, order) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, api_1.soundApi.podcastEpisodes(this.props.podcast.podcastId, { order: order }, offset, limit)];
                });
            });
        };
        PodcastView.prototype.componentWillMount = function () {
            var _this = this;
            api_1.soundApi.podcastEpisodeCount(this.props.podcast.podcastId)
                .then(function (total) {
                var _a = _this.state, offset = _a.offset, limit = _a.limit, order = _a.order;
                _this.getEpisodes(offset, limit, order)
                    .then(function (episodes) { return _this.setState({
                    episodes: episodes,
                    total: total,
                }); });
            });
        };
        PodcastView.prototype.componentDidMount = function () {
            // Scroll to document top
            window.scroll(0, 0);
        };
        PodcastView.prototype.handlePlayPodcast = function (index) {
            if (index === void 0) { index = 0; }
            this.addGlobelPlayPart();
            this.props.handlePlayPodcast(this.props.podcast, this.state.episodes.slice(index));
        };
        PodcastView.prototype.addGlobelPlayPart = function () {
            var _a = this.state, order = _a.order, offset = _a.offset, limit = _a.limit;
            var params = {
                podcastId: this.props.podcast.podcastId,
                params: { order: order },
                offset: offset,
                limit: limit,
            };
            autoLoadNextPlayItems_1.addGlobelPlayPartForPodcast(params);
        };
        PodcastView.prototype.render = function () {
            var _this = this;
            var podcast = this.props.podcast;
            var episodes = this.state.episodes;
            // wait componentWillMount
            if (episodes == null)
                return null;
            var episodesView = episodes.map(function (episode, index) { return (React.createElement(episodeItem_1.default, { key: 'podcast_episode_' + index.toString().padStart(3, '0'), episode: episode, active: false, short: true, thumb: false, handlePlay: function () { return _this.handlePlayPodcast(index); } })); });
            var totalPages = Math.ceil(this.state.total / this.state.limit);
            var paginationView = React.createElement(pagination_1.default, { page: this.state.offset + 1, total: totalPages, size: 11, handleClick: this.changePage });
            var orders = params_1.ORDERS[podcast.origin].podcast.episodes;
            var orderView = React.createElement(navMenu_1.NavMenu, { namespace: 'podcast-orders', thisView: this.state.order, views: orders.map(function (_a) {
                    var id = _a.id, name = _a.name;
                    return ({ name: name, value: id });
                }), handleClick: function (id) { return _this.changeOrder(id); } });
            return (React.createElement("div", { className: 'hw-accelerate' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("section", { className: 'content album' },
                        React.createElement("div", { className: 'container-fluid' },
                            React.createElement("div", { className: 'row' },
                                React.createElement("div", { className: 'col-xs-12 col-lg-3 col-xl-4 col-sticky' },
                                    React.createElement(PodcastEntity, { podcast: podcast, handlePlayPodcast: this.handlePlayPodcast, handleShowRadioViewById: this.props.handleShowRadioViewById, showPodcastMenu: this.props.showPodcastMenu })),
                                React.createElement("div", { className: 'col-xs-12 col-lg-9 col-xl-8 description', dangerouslySetInnerHTML: { __html: podcast.description } }),
                                React.createElement("div", { className: 'col-xs-12 col-lg-9 col-xl-8' }, orderView),
                                React.createElement("div", { className: 'col-xs-12 col-lg-9 col-xl-8' },
                                    React.createElement("section", { className: 'tracklist-container' },
                                        React.createElement("ol", { className: 'tracklist' }, episodesView)))))),
                    paginationView)));
        };
        return PodcastView;
    }(React.Component));
    function mapStateToProps(state) {
        return {
            podcast: state.mainView.podcastView.podcast,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handlePlayPodcast: function (podcast, episodes) { return playPodcast_1.handlePlayPodcast(podcast, episodes).then(function (act) { return dispatch(act); }); },
            handleShowRadioViewById: function (radioId) { return showRadio_1.handleShowRadioViewById(radioId).then(function (act) { return dispatch(act); }); },
            showPodcastMenu: function (e, podcast) { return dispatch(menu_1.showPodcastMenu(e, podcast)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(PodcastView);
});
