var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
define(["require", "exports", "react", "react-redux", "chord/music/common/origin", "chord/platform/utils/common/keys", "chord/workbench/api/utils/statistic", "chord/music/common/size", "chord/workbench/parts/common/component/episodeItem", "chord/workbench/parts/common/component/podcastItem", "chord/workbench/parts/common/component/radioItem", "chord/workbench/parts/common/component/navMenu", "chord/workbench/parts/common/component/pagination", "chord/workbench/parts/common/component/buttons", "chord/workbench/parts/menu/browser/action/menu", "chord/sound/core/api", "chord/sound/common/params"], function (require, exports, React, react_redux_1, origin_1, keys_1, statistic_1, size_1, episodeItem_1, podcastItem_1, radioItem_1, navMenu_1, pagination_1, buttons_1, menu_1, api_1, params_1) {
    'use strict';
    var _a, _b;
    Object.defineProperty(exports, "__esModule", { value: true });
    var NAV_MENU_ITEMS = [
        { id: 'overview', name: 'OVERVIEW' },
        { id: 'episodes', name: 'EPISODES' },
        { id: 'podcasts', name: 'PODCASTS' },
        { id: 'favoritePodcasts', name: 'FAVORITE PODCASTS' },
        { id: 'followings', name: 'FOLLOWINGS' },
    ];
    var INIT_ENTRY = (_a = {},
        _a[origin_1.ORIGIN.ximalaya] = function (type) { return (__assign(__assign({}, params_1.OFFSETS[origin_1.ORIGIN.ximalaya]), { total: null, order: params_1.DEFAULT_ORDER[origin_1.ORIGIN.ximalaya].radio[type], keyword: '', items: [] })); },
        _a);
    var INIT_STATES = (_b = {},
        _b[origin_1.ORIGIN.ximalaya] = {
            init: false,
            view: 'overview',
            episodesEntry: INIT_ENTRY[origin_1.ORIGIN.ximalaya]('episodes'),
            podcastsEntry: INIT_ENTRY[origin_1.ORIGIN.ximalaya]('podcasts'),
            favoritePodcastsEntry: INIT_ENTRY[origin_1.ORIGIN.ximalaya]('favoritePodcasts'),
            followingsEntry: INIT_ENTRY[origin_1.ORIGIN.ximalaya]('followings'),
        },
        _b);
    var RadioView = /** @class */ (function (_super) {
        __extends(RadioView, _super);
        function RadioView(props) {
            var _this = _super.call(this, props) || this;
            var _a = _this.props.radio, origin = _a.origin, radioId = _a.radioId;
            _this.state = __assign(__assign({}, INIT_STATES[origin]), { radioId: radioId });
            _this.init = _this.init.bind(_this);
            _this.changeRadioNavMenuView = _this.changeRadioNavMenuView.bind(_this);
            _this.getEpisodes = _this.getEpisodes.bind(_this);
            _this.getPodcasts = _this.getPodcasts.bind(_this);
            _this.getFavoritePodcasts = _this.getFavoritePodcasts.bind(_this);
            _this.getRadioHeader = _this.getRadioHeader.bind(_this);
            _this.getEpisodeItemsView = _this.getEpisodeItemsView.bind(_this);
            _this.getPodcastItemsView = _this.getPodcastItemsView.bind(_this);
            _this.getFavoritePodcastItemsView = _this.getFavoritePodcastItemsView.bind(_this);
            _this.getFollowingItemsView = _this.getFollowingItemsView.bind(_this);
            _this._itemsView = _this._itemsView.bind(_this);
            _this.changePage = _this.changePage.bind(_this);
            _this.getPaginationView = _this.getPaginationView.bind(_this);
            _this.getOrderView = _this.getOrderView.bind(_this);
            _this.overviewView = _this.overviewView.bind(_this);
            _this.episodesView = _this.episodesView.bind(_this);
            _this.podcastsView = _this.podcastsView.bind(_this);
            _this.favoritePodcastsView = _this.favoritePodcastsView.bind(_this);
            _this.followingsView = _this.followingsView.bind(_this);
            return _this;
        }
        RadioView.prototype.init = function () {
            var _this = this;
            var radioId = this.props.radio.radioId;
            var _a = this.state, episodesEntry = _a.episodesEntry, podcastsEntry = _a.podcastsEntry, favoritePodcastsEntry = _a.favoritePodcastsEntry, followingsEntry = _a.followingsEntry;
            Promise.all([
                api_1.soundApi.radioEpisodeCount(radioId, { keyword: '' }),
                api_1.soundApi.radioPodcastCount(radioId, { keyword: '' }),
                api_1.soundApi.radioFavoritePodcastCount(radioId, { keyword: '' }),
                api_1.soundApi.radioFollowingCount(radioId),
                this.getEpisodes(0, episodesEntry.limit, episodesEntry.order, ''),
                this.getPodcasts(0, podcastsEntry.limit, podcastsEntry.order, ''),
                this.getFavoritePodcasts(0, favoritePodcastsEntry.limit, favoritePodcastsEntry.order, ''),
                this.getFollowings(0, followingsEntry.limit, followingsEntry.order, ''),
            ]).then(function (_a) {
                var _b = __read(_a, 8), episodeCount = _b[0], podcastCount = _b[1], favoritePodcastCount = _b[2], followingCount = _b[3], episodes = _b[4], podcasts = _b[5], favoritePodcasts = _b[6], followings = _b[7];
                _this.setState(function (prevState) {
                    var episodesEntry = __assign(__assign({}, prevState.episodesEntry), { total: episodeCount, items: episodes });
                    var podcastsEntry = __assign(__assign({}, prevState.podcastsEntry), { total: podcastCount, items: podcasts });
                    var favoritePodcastsEntry = __assign(__assign({}, prevState.favoritePodcastsEntry), { total: favoritePodcastCount, items: favoritePodcasts });
                    var followingsEntry = __assign(__assign({}, prevState.followingsEntry), { total: followingCount, items: followings });
                    return __assign(__assign({}, prevState), { init: true, episodesEntry: episodesEntry,
                        podcastsEntry: podcastsEntry,
                        favoritePodcastsEntry: favoritePodcastsEntry,
                        followingsEntry: followingsEntry });
                });
            });
        };
        RadioView.prototype.componentDidMount = function () {
            this.init();
            // Scroll to document top
            window.scroll(0, 0);
        };
        RadioView.getDerivedStateFromProps = function (nextProps, prevState) {
            if (nextProps.radio.radioId != prevState.radioId) {
                var _a = nextProps.radio, origin_2 = _a.origin, radioId = _a.radioId;
                var state = __assign(__assign({}, INIT_STATES[origin_2]), { radioId: radioId });
                return state;
            }
            return null;
        };
        RadioView.prototype.getSnapshotBeforeUpdate = function () {
            if (!this.state.init) {
                this.init();
            }
            return null;
        };
        RadioView.prototype.componentDidUpdate = function () { };
        RadioView.prototype.changeRadioNavMenuView = function (view) {
            var _a = this.state, episodesEntry = _a.episodesEntry, podcastsEntry = _a.podcastsEntry, favoritePodcastsEntry = _a.favoritePodcastsEntry, followingsEntry = _a.followingsEntry;
            switch (view) {
                case 'episodes':
                    this.changePage('episodes', 1, episodesEntry.limit, episodesEntry.order, '');
                    break;
                case 'podcasts':
                    this.changePage('podcasts', 1, podcastsEntry.limit, podcastsEntry.order, '');
                    break;
                case 'favoritePodcasts':
                    this.changePage('favoritePodcasts', 1, favoritePodcastsEntry.limit, favoritePodcastsEntry.order, '');
                    break;
                case 'followings':
                    this.changePage('followings', 1, followingsEntry.limit, followingsEntry.order, '');
                    break;
                default:
                    break;
            }
            this.setState({ view: view });
        };
        RadioView.prototype.getEpisodes = function (offset, limit, order, keyword) {
            return __awaiter(this, void 0, void 0, function () {
                var radioId;
                return __generator(this, function (_a) {
                    radioId = this.props.radio.radioId;
                    return [2 /*return*/, api_1.soundApi.radioEpisodes(radioId, { keyword: keyword, order: order }, offset, limit)];
                });
            });
        };
        RadioView.prototype.getPodcasts = function (offset, limit, order, keyword) {
            return __awaiter(this, void 0, void 0, function () {
                var radioId;
                return __generator(this, function (_a) {
                    radioId = this.props.radio.radioId;
                    return [2 /*return*/, api_1.soundApi.radioPodcasts(radioId, { keyword: keyword, order: order }, offset, limit)];
                });
            });
        };
        RadioView.prototype.getFavoritePodcasts = function (offset, limit, order, keyword) {
            return __awaiter(this, void 0, void 0, function () {
                var radioId;
                return __generator(this, function (_a) {
                    radioId = this.props.radio.radioId;
                    return [2 /*return*/, api_1.soundApi.radioFavoritePodcasts(radioId, { keyword: keyword, order: order }, offset, limit)];
                });
            });
        };
        RadioView.prototype.getFollowings = function (offset, limit, order, keyword) {
            return __awaiter(this, void 0, void 0, function () {
                var radioId;
                return __generator(this, function (_a) {
                    radioId = this.props.radio.radioId;
                    return [2 /*return*/, api_1.soundApi.radioFollowings(radioId, offset, limit)];
                });
            });
        };
        /**
         * offset begins from 1
         */
        RadioView.prototype.changePage = function (type, offset, limit, order, keyword) {
            var _this = this;
            switch (type) {
                case 'episodes':
                    this.getEpisodes(offset - 1, limit, order, keyword)
                        .then(function (episodes) {
                        _this.setState(function (prevState) {
                            var episodesEntry = __assign(__assign({}, prevState.episodesEntry), { items: episodes, offset: offset - 1, limit: limit, order: order, keyword: keyword });
                            return { episodesEntry: episodesEntry };
                        });
                    });
                    break;
                case 'podcasts':
                    this.getPodcasts(offset - 1, limit, order, keyword)
                        .then(function (podcasts) {
                        _this.setState(function (prevState) {
                            var podcastsEntry = __assign(__assign({}, prevState.podcastsEntry), { items: podcasts, offset: offset - 1, limit: limit, order: order, keyword: keyword });
                            return { podcastsEntry: podcastsEntry };
                        });
                    });
                    break;
                case 'favoritePodcasts':
                    this.getFavoritePodcasts(offset - 1, limit, order, keyword)
                        .then(function (podcasts) {
                        _this.setState(function (prevState) {
                            var favoritePodcastsEntry = __assign(__assign({}, prevState.favoritePodcastsEntry), { items: podcasts, offset: offset - 1, limit: limit, order: order, keyword: keyword });
                            return { favoritePodcastsEntry: favoritePodcastsEntry };
                        });
                    });
                    break;
                case 'followings':
                    this.getFollowings(offset - 1, limit, order, keyword)
                        .then(function (radios) {
                        _this.setState(function (prevState) {
                            var followingsEntry = __assign(__assign({}, prevState.followingsEntry), { items: radios, offset: offset - 1, limit: limit, order: order, keyword: keyword });
                            return { followingsEntry: followingsEntry };
                        });
                    });
                    break;
                default:
                    break;
            }
        };
        RadioView.prototype.getPaginationView = function (type, entry) {
            var _this = this;
            var totalPages = Math.ceil(entry.total / entry.limit);
            return React.createElement(pagination_1.default, { page: entry.offset + 1, total: totalPages, size: 11, handleClick: function (page) { return _this.changePage(type, page, entry.limit, entry.order, entry.keyword); } });
        };
        RadioView.prototype.getOrderView = function (type, entry, orders, namespace) {
            var _this = this;
            return React.createElement(navMenu_1.NavMenu, { namespace: namespace, thisView: entry.order, views: orders.map(function (_a) {
                    var id = _a.id, name = _a.name;
                    return ({ name: name, value: id });
                }), handleClick: function (id) { return _this.changePage(type, 1, entry.limit, id, entry.keyword); } });
        };
        RadioView.prototype.getEpisodeItemsView = function () {
            var entry = this.state.episodesEntry;
            return entry.items.map(function (episode, index) {
                return React.createElement(episodeItem_1.default, { key: keys_1.makeListKey(index, 'radio', 'episode'), episode: episode, active: false, short: false, thumb: true, handlePlay: null });
            });
        };
        RadioView.prototype.getPodcastItemsView = function () {
            var entry = this.state.podcastsEntry;
            var podcastsView = entry.items.map(function (podcast, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: keys_1.makeListKey(index, 'radio', 'podcast') },
                React.createElement(podcastItem_1.default, { podcast: podcast }))); });
            return podcastsView;
        };
        RadioView.prototype.getFavoritePodcastItemsView = function () {
            var entry = this.state.favoritePodcastsEntry;
            var favoritePodcastsView = entry.items.map(function (podcast, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: keys_1.makeListKey(index, 'radio', 'favorite', 'podcast') },
                React.createElement(podcastItem_1.default, { podcast: podcast }))); });
            return favoritePodcastsView;
        };
        RadioView.prototype.getFollowingItemsView = function () {
            var entry = this.state.followingsEntry;
            var followingsView = entry.items.map(function (radio, index) { return (React.createElement("div", { className: 'col-xs-6 col-sm-4 col-md-3 col-lg-2 col-xl-2', key: keys_1.makeListKey(index, 'radio', 'followings') },
                React.createElement(radioItem_1.default, { radio: radio }))); });
            return followingsView;
        };
        RadioView.prototype.getRadioHeader = function () {
            var _this = this;
            // Maybe need to set background image
            var radio = this.props.radio;
            var cover = radio.radioCoverPath || api_1.soundApi.resizeImageUrl(radio.origin, radio.radioCoverUrl, size_1.ESize.Middle);
            var userProfileCount = statistic_1.getUserProfileCount(this.props.radio);
            var navMenuView = React.createElement(navMenu_1.NavMenu, { namespace: 'podcast-orders', thisView: this.state.view, views: NAV_MENU_ITEMS.map(function (_a) {
                    var id = _a.id, name = _a.name;
                    return ({ name: name, value: id });
                }), handleClick: function (id) { return _this.changeRadioNavMenuView(id); } });
            return (React.createElement("header", { className: 'user-header user-info' },
                React.createElement("figure", { className: "avatar user-avatar", style: { backgroundImage: "url(\"" + cover + "\")", width: '200px', height: '200px', margin: '10px auto' } }),
                React.createElement("h1", { className: 'user-name' }, radio.radioName),
                React.createElement("h1", { className: 'small', style: { opacity: 0.4 } }, userProfileCount),
                React.createElement("div", { className: 'header-buttons' },
                    React.createElement(buttons_1.MenuButton, { click: function (e) { return _this.props.showRadioMenu(e, radio); } })),
                navMenuView));
        };
        RadioView.prototype.overviewView = function () {
            var episodeItemsView = this.getEpisodeItemsView();
            var podcastItemsView = this.getPodcastItemsView();
            var favoritePodcastItemsView = this.getFavoritePodcastItemsView();
            var followingItemsView = this.getFollowingItemsView();
            var radio = this.props.radio;
            var makeItemsView = function (view, title) { return (React.createElement("section", { className: 'artist-podcasts' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center' } }, title),
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'align-row-wrap grid--limit row' }, view))))); };
            return (React.createElement("div", null,
                React.createElement("section", { className: 'container-fluid' },
                    React.createElement("div", { className: 'row' },
                        React.createElement("div", { className: 'contentSpacing' },
                            React.createElement("div", { className: 'col-xs-12 col-lg-9 col-xl-8 description', dangerouslySetInnerHTML: { __html: radio.description } }),
                            React.createElement("section", { className: 'col-sm-12 col-md-10 col-md-push-1 artist-toptracks' },
                                React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center' } }, "Songs"),
                                React.createElement("section", { className: 'tracklist-container full-width' },
                                    React.createElement("ol", null, episodeItemsView)))))),
                makeItemsView(podcastItemsView, 'Podcasts'),
                makeItemsView(favoritePodcastItemsView, 'Favorite Podcasts'),
                makeItemsView(followingItemsView, 'Followings')));
        };
        RadioView.prototype.episodesView = function () {
            var entry = this.state.episodesEntry;
            var episodeItemsView = this.getEpisodeItemsView();
            var paginationView = this.getPaginationView('episodes', entry);
            var orders = params_1.ORDERS[this.props.radio.origin].radio.episodes;
            var orderView = this.getOrderView('episodes', entry, orders, 'radio-episodes-orders');
            return (React.createElement("section", { className: 'container-fluid' },
                React.createElement("div", { className: 'row' },
                    React.createElement("div", { className: 'contentSpacing' },
                        React.createElement("section", { className: 'col-sm-12 col-md-10 col-md-push-1 artist-toptracks' },
                            React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center', display: 'none' } }, "Episodes"),
                            orderView,
                            React.createElement("section", { className: 'tracklist-container full-width' },
                                React.createElement("ol", null, episodeItemsView))))),
                paginationView));
        };
        RadioView.prototype._itemsView = function (itemsView, orderView, paginationView, title) {
            return (React.createElement("section", { className: 'artist-podcasts' },
                React.createElement("div", { className: 'contentSpacing' },
                    React.createElement("h1", { className: 'search-result-title', style: { textAlign: 'center', display: 'none' } }, title),
                    orderView,
                    React.createElement("div", { className: 'container-fluid container-fluid--noSpaceAround' },
                        React.createElement("div", { className: 'align-row-wrap grid--limit row' }, itemsView)),
                    paginationView)));
        };
        RadioView.prototype.podcastsView = function () {
            var entry = this.state.podcastsEntry;
            var itemsView = this.getPodcastItemsView();
            var paginationView = this.getPaginationView('podcasts', entry);
            var orders = params_1.ORDERS[this.props.radio.origin].radio.podcasts;
            var orderView = this.getOrderView('podcasts', entry, orders, 'radio-podcasts-orders');
            return this._itemsView(itemsView, orderView, paginationView, 'ALBUMS');
        };
        RadioView.prototype.favoritePodcastsView = function () {
            var entry = this.state.favoritePodcastsEntry;
            var itemsView = this.getFavoritePodcastItemsView();
            var paginationView = this.getPaginationView('favoritePodcasts', entry);
            var orders = params_1.ORDERS[this.props.radio.origin].radio.favoritePodcasts;
            var orderView = this.getOrderView('favoritePodcasts', entry, orders, 'radio-favorite-podcasts-orders');
            return this._itemsView(itemsView, orderView, paginationView, 'FAVORITE PLAYLISTS');
        };
        RadioView.prototype.followingsView = function () {
            var entry = this.state.favoritePodcastsEntry;
            var itemsView = this.getFollowingItemsView();
            var paginationView = this.getPaginationView('followings', entry);
            return this._itemsView(itemsView, null, paginationView, 'FOLLOWINGS');
        };
        RadioView.prototype.render = function () {
            if (!this.state || !this.state.init)
                return null;
            var radioHeaderView = this.getRadioHeader();
            var view = this.state.view;
            var contentView;
            if (view == 'overview') {
                contentView = this.overviewView();
            }
            else if (view == 'episodes') {
                contentView = this.episodesView();
            }
            else if (view == 'podcasts') {
                contentView = this.podcastsView();
            }
            else if (view == 'favoritePodcasts') {
                contentView = this.favoritePodcastsView();
            }
            else if (view == 'followings') {
                contentView = this.followingsView();
            }
            else {
                return null;
            }
            return (React.createElement("div", { className: 'hw-accelerate' },
                radioHeaderView,
                contentView));
        };
        return RadioView;
    }(React.Component));
    function mapStateToProps(state) {
        return state.mainView.radioView;
    }
    function mapDispatchToProps(dispatch) {
        return {
            showRadioMenu: function (e, radio) { return dispatch(menu_1.showRadioMenu(e, radio)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(RadioView);
});
