define(["require", "exports", "react", "react-redux", "chord/workbench/parts/menu/browser/component/menu", "chord/workbench/parts/mainView/browser/action/addLibraryItem"], function (require, exports, React, react_redux_1, menu_1, addLibraryItem_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function RadioMenu(_a) {
        var item = _a.item, view = _a.view, top = _a.top, left = _a.left, handleAddLibraryItem = _a.handleAddLibraryItem;
        return view == 'radioMenuView' ?
            React.createElement(menu_1.default, { item: item, name: 'Radio', top: top, left: left, handleAddLibraryItem: handleAddLibraryItem, toQueue: false }) : null;
    }
    function mapStateToProps(state) {
        var _a = state.menu.radioMenu, radio = _a.radio, top = _a.top, left = _a.left;
        return {
            item: radio,
            top: top,
            left: left,
            view: state.menu.view,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handleAddLibraryItem: function (radio) { return dispatch(addLibraryItem_1.handleAddLibraryRadio(radio)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(RadioMenu);
});
