define(["require", "exports", "react", "chord/workbench/parts/menu/browser/component/songMenu", "chord/workbench/parts/menu/browser/component/artistMenu", "chord/workbench/parts/menu/browser/component/albumMenu", "chord/workbench/parts/menu/browser/component/collectionMenu", "chord/workbench/parts/menu/browser/component/userProfileMenu", "chord/workbench/parts/menu/browser/component/episodeMenu", "chord/workbench/parts/menu/browser/component/podcastMenu", "chord/workbench/parts/menu/browser/component/radioMenu", "chord/css!./media/menu"], function (require, exports, React, songMenu_1, artistMenu_1, albumMenu_1, collectionMenu_1, userProfileMenu_1, episodeMenu_1, podcastMenu_1, radioMenu_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function MenuView() {
        return (React.createElement("div", null,
            React.createElement(songMenu_1.default, null),
            React.createElement(artistMenu_1.default, null),
            React.createElement(albumMenu_1.default, null),
            React.createElement(collectionMenu_1.default, null),
            React.createElement(userProfileMenu_1.default, null),
            React.createElement(episodeMenu_1.default, null),
            React.createElement(podcastMenu_1.default, null),
            React.createElement(radioMenu_1.default, null)));
    }
    exports.default = MenuView;
});
