var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/parts/mainView/browser/action/home/recommend", "chord/workbench/parts/common/component/common"], function (require, exports, React, react_redux_1, recommend_1, common_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var Home = /** @class */ (function (_super) {
        __extends(Home, _super);
        function Home(props) {
            return _super.call(this, props) || this;
        }
        Home.prototype.render = function () {
            var _this = this;
            var active = this.props.view == 'homeView';
            return (React.createElement("div", { className: 'navBar-item navBar-item--with-icon-left cursor-pointer', onClick: function () { return _this.props.handleShowRecommendView(); } },
                React.createElement("div", { className: "navBar-link ellipsis-one-line " + (active ? 'navBar-link--active' : 'link-subtle') },
                    React.createElement("span", { className: 'navbar-link__text' }, "Home"),
                    common_1.HomeIcon)));
        };
        return Home;
    }(React.Component));
    function mapStateToProps(state) {
        return {
            view: state.mainView.view,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handleShowRecommendView: function () { return recommend_1.handleShowRecommendView().then(function (act) { return dispatch(act); }); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(Home);
});
