define(["require", "exports", "react", "react-redux", "chord/workbench/parts/common/component/common", "chord/workbench/parts/navigation/browser/action/preference"], function (require, exports, React, react_redux_1, common_1, preference_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function Preference(_a) {
        var handlePreference = _a.handlePreference;
        return (React.createElement("div", { className: 'navBar-item navBar-item--with-icon-left cursor-pointer', onClick: handlePreference },
            React.createElement("div", { className: 'link-subtle navBar-link ellipsis-one-line' },
                React.createElement("span", { className: "navbar-link__text" }, "Preferences"),
                common_1.PreferenceIcon)));
    }
    function mapDispatchToProps(dispatch) {
        return {
            handlePreference: function () { return dispatch(preference_1.handlePreference()); },
        };
    }
    exports.default = react_redux_1.connect(null, mapDispatchToProps)(Preference);
});
