define(["require", "exports", "react", "react-redux"], function (require, exports, React, react_redux_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var style = { paddingRight: '8px', fontSize: '12px' };
    function AudioInfo(_a) {
        var kbps = _a.kbps;
        return kbps ? (React.createElement("span", { style: style }, kbps + "kbps")) : null;
    }
    function mapStateToProps(state) {
        return {
            kbps: state.player.kbps,
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps)(AudioInfo);
});
