var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "react-redux", "chord/workbench/parts/player/browser/action/volume"], function (require, exports, React, react_redux_1, volume_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var VolumeBar = /** @class */ (function (_super) {
        __extends(VolumeBar, _super);
        function VolumeBar(props) {
            var _this = _super.call(this, props) || this;
            _this.box = React.createRef();
            _this.bar = React.createRef();
            _this.slider = React.createRef();
            return _this;
        }
        VolumeBar.prototype.render = function () {
            var _this = this;
            var volume = Math.min(this.props.volume || 1, 1);
            var percent = volume * 100 + "%";
            return (React.createElement("div", { className: 'volume-bar' },
                React.createElement("button", { className: "spoticon-volume-16 control-button", "aria-label": "Mute" }),
                React.createElement("div", { className: 'progress-bar cursor-pointer', ref: this.box, onClick: function (e) { return _this.props.handleVolume(e, _this.box.current); } },
                    React.createElement("div", { className: "middle-align progress-bar__bg" },
                        React.createElement("div", { ref: this.bar, className: "progress-bar__fg", style: { width: percent } }),
                        React.createElement("div", { ref: this.slider, className: "progress-bar__slider", style: { left: percent } })))));
        };
        return VolumeBar;
    }(React.Component));
    function mapStateToProps(state) {
        return {
            volume: state.player.volume,
        };
    }
    function mapDispatchToProps(dispatch) {
        return {
            handleVolume: function (e, box) { return dispatch(volume_1.handleVolume(e, box)); },
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps, mapDispatchToProps)(VolumeBar);
});
