var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports", "chord/base/common/assert"], function (require, exports, assert_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.addToQueue = void 0;
    function addToQueue(state, act) {
        assert_1.equal(act.act, 'c:player:addToQueue');
        var playList;
        var index = state.index;
        switch (act.direction) {
            case 'tail':
                playList = __spread(state.playList, act.playItems);
                break;
            case 'head':
                index = state.index + act.playItems.length;
                playList = __spread(act.playItems, state.playList);
                break;
        }
        return __assign(__assign({}, state), { playList: playList, index: index, id: Date.now() });
    }
    exports.addToQueue = addToQueue;
});
