var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "chord/workbench/api/node/audio", "chord/workbench/api/utils/playItem", "chord/workbench/events/autoLoadNextPlayItems"], function (require, exports, audio_1, playItem_1, autoLoadNextPlayItems_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.playItems = void 0;
    function playItems(state, playList) {
        var index = 0;
        var playing = false;
        if (playList && playList.length) {
            var playItem = playList[0];
            // remove auto-load next playing items for song
            if (playItem.type == 'song')
                autoLoadNextPlayItems_1.removeGlobelPlayPart();
            // TODO: read kbps configuration
            var audio = playItem_1.selectAudio(playItem.audios);
            var audioUrl = audio.path || audio.url;
            audio_1.CAudio.makeAudio(audioUrl, playItem.songId || playItem.episodeId);
            // play now
            audio_1.CAudio.play();
            audio_1.CAudio.volume(state.volume);
            playing = true;
            return __assign(__assign({}, state), { playList: playList, index: index, playing: playing, kbps: audio.kbps, id: Date.now() });
        }
        return __assign({}, state);
    }
    exports.playItems = playItems;
});
