var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
define(["require", "exports"], function (require, exports) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getRandomSample = exports.getRandomFloat = exports.getRandomInt = exports.getRandom = void 0;
    function getRandom() {
        return Math.random();
    }
    exports.getRandom = getRandom;
    function getRandomInt(min, max) {
        min = Math.ceil(min);
        max = Math.floor(max);
        //The maximum and the minimum are inclusive
        return Math.floor(Math.random() * (max - min + 1)) + min;
    }
    exports.getRandomInt = getRandomInt;
    function getRandomFloat(min, max) {
        min = Math.ceil(min);
        max = Math.floor(max);
        //The maximum and the minimum are inclusive
        return Math.floor(Math.random() * (max - min + 1)) + min;
    }
    exports.getRandomFloat = getRandomFloat;
    function getRandomSample(array, size) {
        var range = array.length;
        var result = [];
        var indexRange = [];
        while (result.length < size) {
            if (indexRange.length == 0) {
                indexRange = __spread(Array(range).keys());
            }
            var index = getRandomInt(0, indexRange.length - 1);
            result.push(array[indexRange[index]]);
            indexRange = __spread(indexRange.slice(0, index), indexRange.slice(index + 1));
        }
        return result;
    }
    exports.getRandomSample = getRandomSample;
});
