define(["require", "exports", "chord/base/node/crypto"], function (require, exports, crypto_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.encryptPass = exports.encryptParams = void 0;
    function encryptParams(params) {
        var KEY = Buffer.from("DBEECF8C50FD160E");
        var IV = Buffer.from("1231021386755796");
        var buf = Object.keys(params).sort().map(function (k) { return k + '=' + encodeURIComponent(params[k]); }).join('&');
        var enc = crypto_1.encryptAES(buf, KEY, IV, 'utf8', 'base64', 'cbc');
        return enc;
    }
    exports.encryptParams = encryptParams;
    function encryptPass(params) {
        var tm = Math.floor(Date.now() / 1000);
        var e = crypto_1.md5("baidu_taihe_music_secret_key" + tm).substr(8, 16);
        var KEY = Buffer.from(e);
        var IV = Buffer.from(e);
        var buf = Object.keys(params).sort().map(function (k) { return k + '=' + encodeURIComponent(params[k]); }).join('&');
        var param = crypto_1.encryptAES(buf, KEY, IV, 'utf8', 'base64', 'cbc');
        var sign = crypto_1.md5("baidu_taihe_music" + param + tm);
        return {
            timestamp: tm,
            param: param,
            sign: sign
        };
    }
    exports.encryptPass = encryptPass;
});
