define(["require", "exports"], function (require, exports) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.decrypt = void 0;
    function decrypt(enStr) {
        var str = enStr.slice(1);
        var len = str.length;
        var rows = parseInt(enStr[0]);
        var cols = Math.floor(len / rows);
        var rowsEx = len % rows;
        var mat = [];
        for (var r = 0; r < rows; r++) {
            var length_1 = r < rowsEx ? cols + 1 : cols;
            mat.push(str.slice(0, length_1));
            str = str.slice(length_1);
        }
        str = '';
        for (var i = 0; i < len; i++) {
            str += mat[i % rows][Math.floor(i / rows)];
        }
        str = unescape(str).replace(/\^/g, '0');
        if (str.startsWith('//')) {
            str = 'http:' + str;
        }
        return str;
    }
    exports.decrypt = decrypt;
});
