var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
define(["require", "exports", "chord/platform/log/common/log", "chord/platform/utils/common/paths", "chord/base/node/url", "chord/base/node/_request", "chord/music/common/size", "chord/sound/ximalaya/parser", "chord/sound/ximalaya/crypto"], function (require, exports, log_1, paths_1, url_1, _request_1, size_1, parser_1, crypto_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.XimalayaApi = void 0;
    var loggerWarning = new log_1.Logger(paths_1.filenameToNodeName(__filename), log_1.LogLevel.Warning);
    var XimalayaApi = /** @class */ (function () {
        function XimalayaApi() {
        }
        XimalayaApi.prototype.request = function (node, params, url) {
            if (url === void 0) { url = XimalayaApi.SERVER; }
            return __awaiter(this, void 0, void 0, function () {
                var paramstr, headers, options, result, json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            paramstr = url_1.querystringify(params);
                            url = url + node + '?' + paramstr;
                            headers = __assign(__assign({}, XimalayaApi.HEADERS), { 'xm-sign': crypto_1.getXmSign() });
                            options = {
                                method: 'GET',
                                url: url,
                                headers: headers,
                                gzip: true,
                                resolveWithFullResponse: false,
                            };
                            return [4 /*yield*/, _request_1.request(options)];
                        case 1:
                            result = _a.sent();
                            json = JSON.parse(result.trim());
                            if (json.ret && json.ret != 200 && json.ret != 0) {
                                loggerWarning.warning('[XimalayaApi.request] [Error]: (params, response):', options, json);
                            }
                            return [2 /*return*/, json];
                    }
                });
            });
        };
        /**
         * Error:
         *   "ret":726, "msg":"立即购买畅听"
         */
        XimalayaApi.prototype.demoAudios = function (episodeId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, audio;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.demoAudio + '/' + episodeId, {
                                device: 'pc',
                                isBackend: 'false',
                                _: Date.now(),
                            }, 'https://mpay.ximalaya.com/')];
                        case 1:
                            json = _a.sent();
                            if (json.ret == 726)
                                return [2 /*return*/, null];
                            audio = parser_1.makeDemoAudio(json);
                            return [2 /*return*/, audio];
                    }
                });
            });
        };
        XimalayaApi.prototype.audios = function (episodeId, supKbps) {
            return __awaiter(this, void 0, void 0, function () {
                var json, audio, url;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.audio, { trackIds: episodeId })];
                        case 1:
                            json = _a.sent();
                            url = json.data.tracksForAudioPlay[0].src;
                            if (!url) return [3 /*break*/, 2];
                            audio = parser_1.makeAudio(url);
                            return [3 /*break*/, 4];
                        case 2: return [4 /*yield*/, this.demoAudios(episodeId)];
                        case 3:
                            audio = _a.sent();
                            _a.label = 4;
                        case 4:
                            ;
                            return [2 /*return*/, audio ? [audio] : []];
                    }
                });
            });
        };
        XimalayaApi.prototype.episode = function (episodeId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.episode, { trackId: episodeId })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeEpisode(json.data)];
                    }
                });
            });
        };
        XimalayaApi.prototype.podcast = function (podcastId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.podcast, { albumId: podcastId })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makePodcast(json.data)];
                    }
                });
            });
        };
        XimalayaApi.prototype.podcastEpisodeCount = function (podcastId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.podcastEpisodes, {
                                albumId: podcastId,
                                pageNum: 1,
                                sort: 1,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.trackTotalCount];
                    }
                });
            });
        };
        // order:
        //     0 正序
        //     1 倒序
        XimalayaApi.prototype.podcastEpisodes = function (podcastId, page, order) {
            if (page === void 0) { page = 1; }
            if (order === void 0) { order = '1'; }
            return __awaiter(this, void 0, void 0, function () {
                var json, episodes, _loop_1, this_1, episodes_1, episodes_1_1, episode, state_1, e_1_1;
                var e_1, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.podcastEpisodes, {
                                albumId: podcastId,
                                pageNum: page,
                                sort: order,
                            })];
                        case 1:
                            json = _b.sent();
                            episodes = parser_1.makeEpisodes(json.data.tracks);
                            if (episodes.length == 0)
                                return [2 /*return*/, []];
                            _loop_1 = function (episode) {
                                var tmp_episode, radioId_1, radioOriginalId_1, radioName_1, radioCoverUrl_1, podcastName_1, podcastCoverUrl_1, description_1, _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            _b.trys.push([0, 2, , 3]);
                                            return [4 /*yield*/, this_1.episode(episode.episodeOriginalId)];
                                        case 1:
                                            tmp_episode = _b.sent();
                                            radioId_1 = tmp_episode.radioId, radioOriginalId_1 = tmp_episode.radioOriginalId, radioName_1 = tmp_episode.radioName, radioCoverUrl_1 = tmp_episode.radioCoverUrl, podcastName_1 = tmp_episode.podcastName, podcastCoverUrl_1 = tmp_episode.podcastCoverUrl, description_1 = tmp_episode.description;
                                            return [2 /*return*/, { value: episodes.map(function (s) { return (__assign(__assign({}, s), { radioId: radioId_1,
                                                        radioOriginalId: radioOriginalId_1,
                                                        radioName: radioName_1,
                                                        radioCoverUrl: radioCoverUrl_1,
                                                        podcastName: podcastName_1,
                                                        podcastCoverUrl: podcastCoverUrl_1,
                                                        description: description_1 })); }) }];
                                        case 2:
                                            _a = _b.sent();
                                            return [2 /*return*/, "continue"];
                                        case 3: return [2 /*return*/];
                                    }
                                });
                            };
                            this_1 = this;
                            _b.label = 2;
                        case 2:
                            _b.trys.push([2, 7, 8, 9]);
                            episodes_1 = __values(episodes), episodes_1_1 = episodes_1.next();
                            _b.label = 3;
                        case 3:
                            if (!!episodes_1_1.done) return [3 /*break*/, 6];
                            episode = episodes_1_1.value;
                            return [5 /*yield**/, _loop_1(episode)];
                        case 4:
                            state_1 = _b.sent();
                            if (typeof state_1 === "object")
                                return [2 /*return*/, state_1.value];
                            _b.label = 5;
                        case 5:
                            episodes_1_1 = episodes_1.next();
                            return [3 /*break*/, 3];
                        case 6: return [3 /*break*/, 9];
                        case 7:
                            e_1_1 = _b.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 9];
                        case 8:
                            try {
                                if (episodes_1_1 && !episodes_1_1.done && (_a = episodes_1.return)) _a.call(episodes_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7 /*endfinally*/];
                        case 9: return [2 /*return*/, []];
                    }
                });
            });
        };
        XimalayaApi.prototype.search = function (type, keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.search, {
                                core: type,
                                kw: keyword,
                                page: page,
                                rows: size,
                                spellchecker: 'true',
                                condition: 'relation',
                                device: 'iPhone',
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json];
                    }
                });
            });
        };
        XimalayaApi.prototype.searchEpisodes = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search('track', keyword, page, size)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeEpisodes(json.data.result.response.docs)];
                    }
                });
            });
        };
        XimalayaApi.prototype.searchPodcasts = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search('album', keyword, page, size)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makePodcasts(json.data.result.response.docs)];
                    }
                });
            });
        };
        XimalayaApi.prototype.searchRadios = function (keyword, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.search('user', keyword, page, size)];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeRadios(json.data.result.response.docs)];
                    }
                });
            });
        };
        XimalayaApi.prototype.radio = function (radioId) {
            return __awaiter(this, void 0, void 0, function () {
                var json, radio;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioBasic, {
                                uid: radioId,
                            })];
                        case 1:
                            json = _a.sent();
                            radio = parser_1.makeRadio(json.data);
                            return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioAddons, {
                                    uid: radioId,
                                })];
                        case 2:
                            json = _a.sent();
                            return [2 /*return*/, __assign(__assign({}, radio), { episodeCount: json.data.trackPageInfo.totalCount, followingCount: json.data.followingPageInfo.totalCount, podcastCount: json.data.pubPageInfo.totalCount, favoritePodcastCount: json.data.subscriptionPageInfo.totalCount })];
                    }
                });
            });
        };
        XimalayaApi.prototype.radioEpisodeCount = function (radioId, keyword) {
            if (keyword === void 0) { keyword = ''; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioEpisodes, {
                                page: 1,
                                pageSize: 1,
                                keyWord: keyword || '',
                                uid: radioId,
                                orderType: 2,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.totalCount];
                    }
                });
            });
        };
        /**
         * Episodes the radio created
         *
         * order:
         *     1 正序
         *     2 倒序
         */
        XimalayaApi.prototype.radioEpisodes = function (radioId, page, size, order, keyword) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            if (order === void 0) { order = 2; }
            if (keyword === void 0) { keyword = ''; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioEpisodes, {
                                page: page,
                                pageSize: size,
                                keyWord: '',
                                uid: radioId,
                                orderType: order,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeEpisodes(json.data.trackList)];
                    }
                });
            });
        };
        XimalayaApi.prototype.radioFavoritePodcastCount = function (radioId, keyword) {
            if (keyword === void 0) { keyword = ''; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioFavoritePodcasts, {
                                page: 1,
                                pageSize: 1,
                                keyWord: keyword || '',
                                uid: radioId,
                                subType: 1,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.totalCount];
                    }
                });
            });
        };
        /**
         * Podcasts the radio liked
         *
         * order:
         *     1 综合排序
         *     2 最近更新
         *     3 最近订阅
         */
        XimalayaApi.prototype.radioFavoritePodcasts = function (radioId, page, size, order, keyword) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            if (order === void 0) { order = 1; }
            if (keyword === void 0) { keyword = ''; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioFavoritePodcasts, {
                                page: page,
                                pageSize: size,
                                keyWord: keyword || '',
                                uid: radioId,
                                subType: order,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makePodcasts(json.data.albumsInfo)];
                    }
                });
            });
        };
        XimalayaApi.prototype.radioPodcastCount = function (radioId, keyword) {
            if (keyword === void 0) { keyword = ''; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioPodcasts, {
                                page: 1,
                                pageSize: 1,
                                keyWord: keyword || '',
                                uid: radioId,
                                orderType: 2,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.totalCount];
                    }
                });
            });
        };
        /**
         * Podcasts the radio created
         *
         * order:
         *     1 正序
         *     2 倒序
         */
        XimalayaApi.prototype.radioPodcasts = function (radioId, page, size, order, keyword) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            if (order === void 0) { order = 2; }
            if (keyword === void 0) { keyword = ''; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioPodcasts, {
                                page: page,
                                pageSize: size,
                                keyWord: keyword || '',
                                uid: radioId,
                                orderType: order,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makePodcasts(json.data.albumList)];
                    }
                });
            });
        };
        XimalayaApi.prototype.radioFollowerCount = function (radioId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioFollowers, {
                                page: 1,
                                pageSize: 1,
                                keyWord: '',
                                uid: radioId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.totalCount];
                    }
                });
            });
        };
        XimalayaApi.prototype.radioFollowers = function (radioId, page, size) {
            if (page === void 0) { page = 0; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioFollowers, {
                                page: page,
                                pageSize: size,
                                keyWord: '',
                                uid: radioId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeRadios(json.data.fansPageInfo)];
                    }
                });
            });
        };
        XimalayaApi.prototype.radioFollowingCount = function (radioId) {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioFollowings, {
                                page: 1,
                                pageSize: 1,
                                keyWord: '',
                                uid: radioId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.totalCount];
                    }
                });
            });
        };
        XimalayaApi.prototype.radioFollowings = function (radioId, page, size) {
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.radioFollowings, {
                                page: page,
                                pageSize: size,
                                keyWord: '',
                                uid: radioId,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makeRadios(json.data.followingsPageInfo)];
                    }
                });
            });
        };
        XimalayaApi.prototype.podcastListOptions = function () {
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.podcastListOptions, {})];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makePodcastListOptions(json.data)];
                    }
                });
            });
        };
        XimalayaApi.prototype.podcastOptionSubs = function (category, subCategory) {
            return __awaiter(this, void 0, void 0, function () {
                var json, option, options;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.podcastOptionSubs, {
                                category: category,
                                subcategory: subCategory,
                            })];
                        case 1:
                            json = _a.sent();
                            option = {
                                id: null,
                                name: '排序',
                                type: 'sort',
                                items: [
                                    {
                                        id: '0',
                                        name: '综合排序',
                                        type: 'sort',
                                    },
                                    {
                                        id: '2',
                                        name: '播放最多',
                                        type: 'sort',
                                    },
                                    {
                                        id: '1',
                                        name: '最近更新',
                                        type: 'sort',
                                    }
                                ],
                            };
                            options = parser_1.makePodcastOptionSubs(json.data);
                            options.push(option);
                            return [2 /*return*/, options];
                    }
                });
            });
        };
        XimalayaApi.prototype.podcastListCount = function (category, subCategory, meta) {
            if (meta === void 0) { meta = ''; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.podcastList, {
                                category: category,
                                subcategory: subCategory,
                                meta: meta,
                                sort: '0',
                                page: 1,
                                perPage: 1,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, json.data.total];
                    }
                });
            });
        };
        XimalayaApi.prototype.podcastList = function (category, subCategory, meta, sort, page, size) {
            if (meta === void 0) { meta = ''; }
            if (sort === void 0) { sort = '0'; }
            if (page === void 0) { page = 1; }
            if (size === void 0) { size = 10; }
            return __awaiter(this, void 0, void 0, function () {
                var json;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.request(XimalayaApi.NODE_MAP.podcastList, {
                                category: category,
                                subcategory: subCategory,
                                meta: meta,
                                sort: sort,
                                page: page,
                                perPage: size,
                            })];
                        case 1:
                            json = _a.sent();
                            return [2 /*return*/, parser_1.makePodcasts(json.data.albums)];
                    }
                });
            });
        };
        XimalayaApi.prototype.resizeImageUrl = function (url, size) {
            if (size < size_1.ESize.Middle) {
                // Big
                return url + '!strip=1&quality=7&magick=webp&op_type=5&upload_type=album&name=mobile_large&device_type=ios';
            }
            else {
                // small
                return url + '!strip=1&quality=7&magick=webp&op_type=5&upload_type=cover&name=web_large&device_type=ios';
            }
        };
        XimalayaApi.prototype.fromURL = function (input) {
            return __awaiter(this, void 0, void 0, function () {
                var chunks, items, chunks_1, chunks_1_1, chunk, m, originId, type, matchList, matchList_1, matchList_1_1, _a, re, tp, item, _b, e_2_1;
                var e_2, _c, e_3, _d;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            chunks = input.split(' ');
                            items = [];
                            _e.label = 1;
                        case 1:
                            _e.trys.push([1, 12, 13, 14]);
                            chunks_1 = __values(chunks), chunks_1_1 = chunks_1.next();
                            _e.label = 2;
                        case 2:
                            if (!!chunks_1_1.done) return [3 /*break*/, 11];
                            chunk = chunks_1_1.value;
                            m = void 0;
                            originId = void 0;
                            type = void 0;
                            matchList = [
                                // radio
                                [/zhubo\/(\d+)/, 'radio'],
                                // episode
                                [/\w+\/\d+\/(\d+)/, 'episode'],
                                // podcast
                                [/\w+\/(\d+)/, 'podcast'],
                            ];
                            try {
                                for (matchList_1 = (e_3 = void 0, __values(matchList)), matchList_1_1 = matchList_1.next(); !matchList_1_1.done; matchList_1_1 = matchList_1.next()) {
                                    _a = __read(matchList_1_1.value, 2), re = _a[0], tp = _a[1];
                                    m = re.exec(chunk);
                                    if (m) {
                                        type = tp;
                                        originId = m[1];
                                        break;
                                    }
                                }
                            }
                            catch (e_3_1) { e_3 = { error: e_3_1 }; }
                            finally {
                                try {
                                    if (matchList_1_1 && !matchList_1_1.done && (_d = matchList_1.return)) _d.call(matchList_1);
                                }
                                finally { if (e_3) throw e_3.error; }
                            }
                            if (!originId) return [3 /*break*/, 10];
                            item = void 0;
                            _b = type;
                            switch (_b) {
                                case 'episode': return [3 /*break*/, 3];
                                case 'podcast': return [3 /*break*/, 5];
                                case 'radio': return [3 /*break*/, 7];
                            }
                            return [3 /*break*/, 9];
                        case 3: return [4 /*yield*/, this.episode(originId)];
                        case 4:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 10];
                        case 5: return [4 /*yield*/, this.podcast(originId)];
                        case 6:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 10];
                        case 7: return [4 /*yield*/, this.radio(originId)];
                        case 8:
                            item = _e.sent();
                            items.push(item);
                            return [3 /*break*/, 10];
                        case 9: return [3 /*break*/, 10];
                        case 10:
                            chunks_1_1 = chunks_1.next();
                            return [3 /*break*/, 2];
                        case 11: return [3 /*break*/, 14];
                        case 12:
                            e_2_1 = _e.sent();
                            e_2 = { error: e_2_1 };
                            return [3 /*break*/, 14];
                        case 13:
                            try {
                                if (chunks_1_1 && !chunks_1_1.done && (_c = chunks_1.return)) _c.call(chunks_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                            return [7 /*endfinally*/];
                        case 14: return [2 /*return*/, items];
                    }
                });
            });
        };
        XimalayaApi.SERVER = 'https://www.ximalaya.com/';
        XimalayaApi.HEADERS = {
            'Referer': 'https://www.ximalaya.com/',
            'Radio-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36',
            'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8',
        };
        XimalayaApi.NODE_MAP = {
            demoAudio: 'mobile/track/pay',
            audio: 'revision/play/tracks',
            episode: 'revision/track/trackPageInfo',
            podcast: 'revision/album',
            podcastEpisodes: 'revision/album/getTracksList',
            search: 'revision/search',
            radioBasic: 'revision/user/basic',
            radioAddons: 'revision/user',
            radioEpisodes: 'revision/user/track',
            radioPodcasts: 'revision/user/pub',
            radioFavoritePodcasts: 'revision/user/sub',
            radioFollowers: 'revision/user/fans',
            radioFollowings: 'revision/user/following',
            podcastListOptions: 'revision/category/allCategoryInfo',
            podcastOptionSubs: 'revision/category/detailCategoryPageInfo',
            podcastList: 'revision/category/queryCategoryPageAlbums',
        };
        return XimalayaApi;
    }());
    exports.XimalayaApi = XimalayaApi;
});
