var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
define(["require", "exports", "chord/workbench/api/common/state/offset"], function (require, exports, offset_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.initiateLibraryViewState = exports.initiateLibraryResultState = void 0;
    var MAX_ID = Math.pow(2, 32) - 1;
    function initiateLibraryResultState() {
        return {
            view: 'top',
            songs: [],
            albums: [],
            artists: [],
            collections: [],
            userProfiles: [],
            episodes: [],
            podcasts: [],
            radios: [],
            songsOffset: __assign(__assign({}, offset_1.initiateOffset()), { offset: MAX_ID }),
            albumsOffset: __assign(__assign({}, offset_1.initiateOffset()), { offset: MAX_ID }),
            artistsOffset: __assign(__assign({}, offset_1.initiateOffset()), { offset: MAX_ID }),
            collectionsOffset: __assign(__assign({}, offset_1.initiateOffset()), { offset: MAX_ID }),
            userProfilesOffset: __assign(__assign({}, offset_1.initiateOffset()), { offset: MAX_ID }),
            episodesOffset: __assign(__assign({}, offset_1.initiateOffset()), { offset: MAX_ID }),
            podcastsOffset: __assign(__assign({}, offset_1.initiateOffset()), { offset: MAX_ID }),
            radiosOffset: __assign(__assign({}, offset_1.initiateOffset()), { offset: MAX_ID }),
        };
    }
    exports.initiateLibraryResultState = initiateLibraryResultState;
    function initiateLibraryViewState() {
        return {
            keyword: '',
            result: initiateLibraryResultState(),
        };
    }
    exports.initiateLibraryViewState = initiateLibraryViewState;
});
