var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "electron"], function (require, exports, React, electron_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var WindowsControlBar = /** @class */ (function (_super) {
        __extends(WindowsControlBar, _super);
        function WindowsControlBar(props) {
            return _super.call(this, props) || this;
        }
        WindowsControlBar.prototype.min = function () {
            var win = electron_1.remote.getCurrentWindow();
            win.minimize();
        };
        WindowsControlBar.prototype.max = function () {
            var win = electron_1.remote.getCurrentWindow();
            win.maximize();
        };
        WindowsControlBar.prototype.close = function () {
            var win = electron_1.remote.getCurrentWindow();
            win.close();
        };
        WindowsControlBar.prototype.toggleDevTools = function () {
            var win = electron_1.remote.getCurrentWindow();
            win.webContents.toggleDevTools();
        };
        WindowsControlBar.prototype.report = function () {
            electron_1.shell.openExternal('https://github.com/PeterDing/chord/issues');
        };
        WindowsControlBar.prototype.render = function () {
            return (React.createElement("div", { className: 'window-controls' },
                React.createElement("div", { className: 'window-controls-container' },
                    React.createElement("div", { className: 'window-icon-bg window-close-bg', onClick: this.close },
                        React.createElement("div", { className: 'window-icon window-close cursor-pointer' })),
                    React.createElement("div", { className: 'window-icon-bg', onClick: this.min },
                        React.createElement("div", { className: 'window-icon window-minimize cursor-pointer' })),
                    React.createElement("div", { className: 'window-icon-bg', onClick: this.max },
                        React.createElement("div", { className: 'window-icon window-max-restore window-maximize cursor-pointer' })),
                    React.createElement("div", { className: 'window-icon-bg', title: 'Toggle DevTools', onClick: this.toggleDevTools },
                        React.createElement("div", { className: 'window-icon dev-tools cursor-pointer' })),
                    React.createElement("div", { className: 'window-icon-bg', title: 'report', onClick: this.report },
                        React.createElement("div", { className: 'window-icon report cursor-pointer' })))));
        };
        return WindowsControlBar;
    }(React.Component));
    exports.default = WindowsControlBar;
});
