var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react"], function (require, exports, React) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Card = void 0;
    var Card = /** @class */ (function (_super) {
        __extends(Card, _super);
        function Card(props) {
            return _super.call(this, props) || this;
        }
        Card.prototype.render = function () {
            var _this = this;
            var infos = this.props.infos ? this.props.infos.map(function (info, index) {
                return (React.createElement("div", { className: 'mo-meta', key: index },
                    React.createElement("div", { className: 'react-contextmenu-wrapper' },
                        React.createElement("span", { className: info.act && 'link-subtle a-like cursor-pointer', onClick: function () { info.act && info.act(); } }, info.item))));
            }) : null;
            // There is only two shape, reactangle and circle, default is rectangle
            var shape = this.props.shape == 'circle' ? 'rounded' : '';
            var button = this.props.button ?
                React.createElement("button", { className: 'cover-art-playback cursor-pointer', onClick: function () { return _this.props.button.act(); } }, this.props.button.item) : null;
            return (React.createElement("div", { draggable: !!this.props.draggable },
                React.createElement("div", { className: 'media-object', style: { maxWidth: '300px' } },
                    React.createElement("div", { className: 'media-object-hoverable' },
                        React.createElement("div", { className: 'react-contextmenu-wrapper', onContextMenu: function (e) { return _this.props.menu(e); } },
                            React.createElement("div", { className: 'cover-art shadow actionable ' + shape + ' linking cursor-pointer cover-art--with-auto-height', "aria-hidden": 'true', style: { width: 'auto', height: 'auto' } },
                                React.createElement("div", { onClick: function () { return _this.props.cover.act(); } },
                                    this.props.defaultCover,
                                    React.createElement("div", { className: 'cover-art-image cover-art-image-loaded', style: { backgroundImage: "url('" + this.props.cover.item + "')" } })),
                                button)),
                        React.createElement("div", { className: 'mo-info' },
                            React.createElement("div", { className: 'react-contextmenu-wrapper' },
                                React.createElement("span", { className: 'mo-info-name' }, this.props.name)))),
                    infos)));
        };
        return Card;
    }(React.Component));
    exports.Card = Card;
});
