var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "react", "chord/workbench/parts/mainView/browser/component/preference/user/login", "chord/workbench/parts/mainView/browser/component/preference/configuration/configuration", "chord/workbench/parts/common/component/navMenu", "chord/css!../../media/preference"], function (require, exports, React, login_1, configuration_1, navMenu_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    var PreferenceView = /** @class */ (function (_super) {
        __extends(PreferenceView, _super);
        function PreferenceView(props) {
            var _this = _super.call(this, props) || this;
            _this.state = { view: 'accounts' };
            _this.changeView = _this.changeView.bind(_this);
            return _this;
        }
        PreferenceView.prototype.changeView = function (view) {
            this.setState({ view: view });
        };
        PreferenceView.prototype.render = function () {
            var views = [
                { name: 'ACCOUNTS', value: 'accounts' },
                { name: 'CONFIGURATION', value: 'configuration' },
            ];
            var navMenu = React.createElement(navMenu_1.NavMenu, { namespace: 'preference-navmenu', thisView: this.state.view, views: views, handleClick: this.changeView });
            var content;
            switch (this.state.view) {
                case 'accounts':
                    content = (React.createElement("div", null,
                        React.createElement(login_1.XiamiLogin, null),
                        React.createElement(login_1.NeteaseLogin, null),
                        React.createElement(login_1.QQLogin, null)));
                    break;
                case 'configuration':
                    content = React.createElement(configuration_1.default, null);
                    break;
            }
            return (React.createElement("div", null,
                navMenu,
                content));
        };
        return PreferenceView;
    }(React.Component));
    exports.default = PreferenceView;
});
