define(["require", "exports", "react", "react-redux", "chord/workbench/parts/mainView/browser/component/search/searchInput", "chord/workbench/parts/mainView/browser/component/search/searchResult", "chord/workbench/parts/mainView/browser/component/search/searchHistory"], function (require, exports, React, react_redux_1, searchInput_1, searchResult_1, searchHistory_1) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    function SearchView(_a) {
        var view = _a.view;
        var View;
        if (view == 'searchHistory') {
            View = React.createElement(searchHistory_1.default, null);
        }
        else if (view == 'searchResult') {
            View = React.createElement(searchResult_1.default, null);
        }
        else {
            return null;
        }
        return (React.createElement("div", { className: 'hw-accelerate' },
            React.createElement("section", null,
                React.createElement("div", null,
                    React.createElement(searchInput_1.default, null)),
                React.createElement("div", null, View))));
    }
    function mapStateToProps(state) {
        return {
            view: state.mainView.searchView.view,
        };
    }
    exports.default = react_redux_1.connect(mapStateToProps)(SearchView);
});
