define(["require", "exports"], function (require, exports) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.showRadioMenu = exports.showPodcastMenu = exports.showEpisodeMenu = exports.showUserProfileMenu = exports.showCollectionMenu = exports.showAlbumMenu = exports.showArtistMenu = exports.showSongMenu = void 0;
    function showSongMenu(e, song) {
        e.preventDefault();
        return {
            type: 'c:menu:showSongMenu',
            act: 'c:menu:showSongMenu',
            top: e.screenY - 50,
            left: e.screenX - 50,
            song: song
        };
    }
    exports.showSongMenu = showSongMenu;
    function showArtistMenu(e, artist) {
        e.preventDefault();
        return {
            type: 'c:menu:showArtistMenu',
            act: 'c:menu:showArtistMenu',
            top: e.screenY - 50,
            left: e.screenX - 50,
            artist: artist
        };
    }
    exports.showArtistMenu = showArtistMenu;
    function showAlbumMenu(e, album) {
        e.preventDefault();
        return {
            type: 'c:menu:showAlbumMenu',
            act: 'c:menu:showAlbumMenu',
            top: e.screenY - 50,
            left: e.screenX - 50,
            album: album
        };
    }
    exports.showAlbumMenu = showAlbumMenu;
    function showCollectionMenu(e, collection) {
        e.preventDefault();
        return {
            type: 'c:menu:showCollectionMenu',
            act: 'c:menu:showCollectionMenu',
            top: e.screenY - 50,
            left: e.screenX - 50,
            collection: collection
        };
    }
    exports.showCollectionMenu = showCollectionMenu;
    function showUserProfileMenu(e, userProfile) {
        e.preventDefault();
        return {
            type: 'c:menu:showUserProfileMenu',
            act: 'c:menu:showUserProfileMenu',
            top: e.screenY - 50,
            left: e.screenX - 50,
            userProfile: userProfile
        };
    }
    exports.showUserProfileMenu = showUserProfileMenu;
    // Sound
    function showEpisodeMenu(e, episode) {
        e.preventDefault();
        return {
            type: 'c:menu:showEpisodeMenu',
            act: 'c:menu:showEpisodeMenu',
            top: e.screenY - 50,
            left: e.screenX - 50,
            episode: episode
        };
    }
    exports.showEpisodeMenu = showEpisodeMenu;
    function showPodcastMenu(e, podcast) {
        e.preventDefault();
        return {
            type: 'c:menu:showPodcastMenu',
            act: 'c:menu:showPodcastMenu',
            top: e.screenY - 50,
            left: e.screenX - 50,
            podcast: podcast
        };
    }
    exports.showPodcastMenu = showPodcastMenu;
    function showRadioMenu(e, radio) {
        e.preventDefault();
        return {
            type: 'c:menu:showRadioMenu',
            act: 'c:menu:showRadioMenu',
            top: e.screenY - 50,
            left: e.screenX - 50,
            radio: radio
        };
    }
    exports.showRadioMenu = showRadioMenu;
});
