define(["require", "exports", "chord/workbench/parts/player/browser/reducer/main", "chord/workbench/parts/mainView/browser/reducer/main", "chord/workbench/parts/menu/browser/reducer/main", "chord/workbench/parts/notification/reducer/main"], function (require, exports, main_1, main_2, main_3, main_4) {
    'use strict';
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.map = void 0;
    function map(act) {
        if (act.startsWith('c:player:')) {
            return {
                reducer: main_1.playerReducer,
                node: 'player',
            };
        }
        else if (act.startsWith('c:mainView:')) {
            return {
                reducer: main_2.mainViewReducer,
                node: 'mainView',
            };
        }
        else if (act.startsWith('c:notification:')) {
            return {
                reducer: main_4.notificationReducer,
                node: 'notification',
            };
        }
        else if (act.startsWith('c:menu:')) {
            return {
                reducer: main_3.menuReducer,
                node: 'menu',
            };
        }
        else {
            return null;
        }
    }
    exports.map = map;
});
